<?xml version="1.0" encoding="UTF-8"?>
<!--
  ~ #%L
  ~ u-count
  ~ %%
  ~ Copyright (C) 2016 - 2018 République et Canton de Genève
  ~ %%
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  ~ GNU General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  ~ #L%
  -->

<?import ch.ge.ve.javafx.gui.control.MessageContainer?>
<?import ch.ge.ve.ucount.gui.validator.MinMaxNumberValidator?>
<?import ch.ge.ve.ucount.gui.validator.NbrOfSharesToRecoverValidator?>
<?import com.jfoenix.controls.JFXButton?>
<?import com.jfoenix.controls.JFXTextField?>
<?import com.jfoenix.validation.NumberValidator?>
<?import com.jfoenix.validation.RequiredFieldValidator?>
<?import javafx.scene.control.Label?>
<?import javafx.scene.layout.HBox?>
<?import javafx.scene.layout.StackPane?>
<?import javafx.scene.layout.VBox?>
<StackPane xmlns="http://javafx.com/javafx" xmlns:fx="http://javafx.com/fxml"
           styleClass="card"
           fx:controller="ch.ge.ve.ucount.gui.controller.GenerateElectionOfficerKey">
    <VBox alignment="CENTER">
        <HBox styleClass="card-header">
            <Label text="%generate-election-officer-key.title" styleClass="card-title"/>
        </HBox>

        <MessageContainer fx:id="errorMessageContainer" alignment="CENTER_LEFT" messageType="ERROR"/>
        <MessageContainer fx:id="successMessageContainer" styleClass="election-officer-key-success-box"
                          alignment="CENTER" messageType="SUCCESS"/>

        <VBox alignment="CENTER" styleClass="card-content" fx:id="nbrOfSharesInputGroupBox" spacing="20">
            <VBox spacing="10">
                <Label styleClass="h4,mandatory" text="%generate-election-officer-key.nbr-of-shares"/>
                <HBox alignment="CENTER_LEFT" spacing="5">
                    <JFXTextField fx:id="nbrOfSharesField" HBox.hgrow="ALWAYS">
                        <validators>
                            <RequiredFieldValidator message="%error.no-number"/>
                            <NumberValidator message="%error.not-a-number"/>
                            <MinMaxNumberValidator baseMessage="%error.number-not-in-range"
                                                   minNumber="${controller.electionOfficerKeyConfiguration.minNbrOfShares}"
                                                   maxNumber="${controller.electionOfficerKeyConfiguration.maxNbrOfShares}"/>
                        </validators>
                    </JFXTextField>
                </HBox>
            </VBox>
            <VBox spacing="10">
                <Label styleClass="h4,mandatory" text="%generate-election-officer-key.min-nbr-of-shares-to-recover"/>
                <HBox alignment="CENTER_LEFT" spacing="5">
                    <JFXTextField fx:id="minNbrOfSharesToRecoverField" HBox.hgrow="ALWAYS">
                        <validators>
                            <RequiredFieldValidator message="%error.no-number"/>
                            <NumberValidator message="%error.not-a-number"/>
                            <MinMaxNumberValidator baseMessage="%error.number-not-in-range"
                                                   minNumber="${controller.electionOfficerKeyConfiguration.minNbrOfSharesToRecover}"
                                                   maxNumber="${controller.electionOfficerKeyConfiguration.maxNbrOfSharesToRecover}"/>
                            <NbrOfSharesToRecoverValidator
                                    baseMessage="%error.min-nbr-of-shares-to-recover-not-in-range"
                                    nbrOfSharesText="${nbrOfSharesField.text}"/>
                        </validators>
                    </JFXTextField>
                </HBox>
            </VBox>
        </VBox>
        <HBox fx:id="submitNbrOfSharesBox" alignment="BOTTOM_RIGHT" styleClass="card-actions">
            <JFXButton styleClass="button-primary-raised"
                       text="%generate-election-officer-key.submit-nbr-of-shares"
                       buttonType="RAISED"
                       onMousePressed="#generateElectionOfficerKey"/>
        </HBox>

        <VBox alignment="CENTER" fx:id="privateKeyInputGroupsBox" styleClass="stepper-container" visible="false"
              managed="false"/>
        <HBox fx:id="submitPrivateKeyBox" alignment="BOTTOM_RIGHT" styleClass="card-actions"
              visible="false" managed="false">
            <JFXButton styleClass="button-primary-raised"
                       text="%generate-election-officer-key.submit-share"
                       buttonType="RAISED"
                       onMousePressed="#persistShareOrPublicKey"/>
        </HBox>

    </VBox>
</StackPane>
